diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/test/wifi-primary-channels-test.cc ns-3.36/src/wifi/test/wifi-primary-channels-test.cc
--- ns-3.35/src/wifi/test/wifi-primary-channels-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/test/wifi-primary-channels-test.cc	2022-04-30 18:23:58.222735200 -0700
@@ -18,6 +18,8 @@
  * Author: Stefano Avallone <stavallo@unina.it>
  */
 
+#include "ns3/boolean.h"
+#include "ns3/enum.h"
 #include "ns3/test.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/mobility-helper.h"
@@ -31,6 +33,7 @@
 #include "ns3/he-phy.h"
 #include "ns3/he-configuration.h"
 #include "ns3/ctrl-headers.h"
+#include "ns3/tuple.h"
 #include <bitset>
 #include <algorithm>
 #include <sstream>
@@ -265,14 +268,14 @@
                                     WifiTxVector txVector, std::vector<bool> perMpduStatus)
 {
   // if the BSS color is zero, this AP might receive the frame sent by another AP. Given that
-  // stations only send TB PPDUs, we discard this frame if the TX vector is UL MU.
+  // stations only send TB PPDUs, we ignore this frame if the TX vector is not UL MU.
   if (psdu->GetNMpdus () == 1 && psdu->GetHeader (0).IsQosData () && txVector.IsUlMu ())
     {
       auto dev = DynamicCast<WifiNetDevice> (m_apDevices.Get (bss));
 
       uint16_t staId = txVector.GetHeMuUserInfoMap ().begin ()->first;
       uint8_t station = staId - 1;
-      NS_LOG_INFO ("RECEIVED FROM BSS=" << +bss << " STA=" << +station
+      NS_LOG_INFO ("RECEIVED FROM BSSID=" << psdu->GetHeader (0).GetAddr3 () << " STA=" << +station
                    << "  " << *psdu);
       // the MAC received a PSDU containing a QoS data frame from the PHY
       NS_TEST_EXPECT_MSG_EQ (m_received[bss].test (station), false, "AP of BSS " << +bss
@@ -294,7 +297,7 @@
   RngSeedManager::SetSeed (1);
   RngSeedManager::SetRun (40);
   int64_t streamNumber = 100;
-  uint16_t frequency;
+  uint8_t channelNum;
 
   // we create as many stations per BSS as the number of 26-tone RUs in a channel
   // of the configured width
@@ -302,19 +305,19 @@
     {
       case 20:
         m_nStationsPerBss = 9;
-        frequency = 5180;
+        channelNum = 36;
         break;
       case 40:
         m_nStationsPerBss = 18;
-        frequency = 5190;
+        channelNum = 38;
         break;
       case 80:
         m_nStationsPerBss = 37;
-        frequency = 5210;
+        channelNum = 42;
         break;
       case 160:
         m_nStationsPerBss = 74;
-        frequency = 5250;
+        channelNum= 50;
         break;
       default:
         NS_ABORT_MSG ("Channel width (" << m_channelWidth << ") not allowed");
@@ -340,10 +343,9 @@
 
   SpectrumWifiPhyHelper phy;
   phy.SetChannel (spectrumChannel);
-  phy.Set ("Frequency", UintegerValue (frequency));  // same frequency for all BSSes
 
   WifiHelper wifi;
-  wifi.SetStandard (WIFI_STANDARD_80211ax_5GHZ);
+  wifi.SetStandard (WIFI_STANDARD_80211ax);
   wifi.SetRemoteStationManager ("ns3::ConstantRateWifiManager");
 
   WifiMacHelper mac;
@@ -351,17 +353,21 @@
                "Ssid", SsidValue (Ssid ("non-existent-ssid")),
                "WaitBeaconTimeout", TimeValue (MicroSeconds (102400))); // same as BeaconInterval
 
+  TupleValue<UintegerValue, UintegerValue, EnumValue, UintegerValue> channelValue;
+
   // Each BSS uses a distinct primary20 channel
   for (uint8_t bss = 0; bss < m_nBss; bss++)
     {
-      phy.Set ("Primary20MHzIndex", UintegerValue (bss));
+      channelValue.Set (WifiPhy::ChannelTuple {channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, bss});
+      phy.Set ("ChannelSettings", channelValue);
 
       m_staDevices.push_back (wifi.Install (phy, mac, wifiStaNodes[bss]));
     }
 
   for (uint8_t bss = 0; bss < m_nBss; bss++)
     {
-      phy.Set ("Primary20MHzIndex", UintegerValue (bss));
+      channelValue.Set (WifiPhy::ChannelTuple {channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, bss});
+      phy.Set ("ChannelSettings", channelValue);
 
       mac.SetType ("ns3::ApWifiMac",
                   "Ssid", SsidValue (Ssid ("wifi-ssid-" + std::to_string (bss))),
@@ -370,7 +376,7 @@
 
       m_apDevices.Add (wifi.Install (phy, mac, wifiApNodes.Get (bss)));
     }
-  
+
   // Assign fixed streams to random variables in use
   streamNumber = wifi.AssignStreams (m_apDevices, streamNumber);
   for (uint8_t bss = 0; bss < m_nBss; bss++)
@@ -611,7 +617,7 @@
     }
 
   /*
-   * Repeat the same scheme as before with DL MU transmissions. For each transmission
+   * Repeat the same scheme as before with UL MU transmissions. For each transmission
    * channel width, every round is repeated as many times as the number of ways in
    * which we can partition the transmission channel width in equal sized RUs.
    */
@@ -703,8 +709,8 @@
 
   for (std::size_t i = 1; i <= nRus; i++)
     {
-      std::size_t index = (txChannelWidth == 160 && i > nRus / 2 ? i - nRus / 2 : i);
-      bool primary80 = (txChannelWidth == 160 && i > nRus / 2 ? false : true);
+      bool primary80 = !(txChannelWidth == 160 && i > nRus / 2);
+      std::size_t index = (primary80 ? i : i - nRus / 2);
 
       auto staDev = DynamicCast<WifiNetDevice> (m_staDevices[bss].Get (i - 1));
       uint16_t staId = DynamicCast<StaWifiMac> (staDev->GetMac ())->GetAssociationId ();
@@ -747,20 +753,22 @@
 
   Time duration = Seconds (0);
   uint16_t length = 0;
+  WifiTxVector trigVector (HePhy::GetHeMcs8 (), 0, WIFI_PREAMBLE_HE_TB, 3200, 1, 1, 0, txChannelWidth, false, false, false, bssColor);
 
   for (std::size_t i = 1; i <= nRus; i++)
     {
       NS_LOG_INFO ("*** BSS " << +bss << " STA " << i - 1 << " transmits on primary "
                    << txChannelWidth << " MHz channel an HE TB PPDU (RU type: " << ruType << ")");
 
-      std::size_t index = (txChannelWidth == 160 && i > nRus / 2 ? i - nRus / 2 : i);
-      bool primary80 = (txChannelWidth == 160 && i > nRus / 2 ? false : true);
+      bool primary80 = !(txChannelWidth == 160 && i > nRus / 2);
+      std::size_t index = (primary80 ? i : i - nRus / 2);
 
       auto staDev = DynamicCast<WifiNetDevice> (m_staDevices[bss].Get (i - 1));
       uint16_t staId = DynamicCast<StaWifiMac> (staDev->GetMac ())->GetAssociationId ();
 
       WifiTxVector txVector (HePhy::GetHeMcs8 (), 0, WIFI_PREAMBLE_HE_TB, 3200, 1, 1, 0, txChannelWidth, false, false, false, bssColor);
       txVector.SetHeMuUserInfo (staId, {{ruType, index, primary80}, HePhy::GetHeMcs8 (), 1});
+      trigVector.SetHeMuUserInfo (staId, {{ruType, index, primary80}, HePhy::GetHeMcs8 (), 1});
 
       hdr.SetAddr2 (staDev->GetMac ()->GetAddress ());
       Ptr<const WifiPsdu> psdu = Create<const WifiPsdu> (Create<Packet> (1000), hdr);
@@ -770,13 +778,18 @@
           // calculate just once
           duration = WifiPhy::CalculateTxDuration (psdu->GetSize (), txVector,
                                                    staDev->GetMac ()->GetWifiPhy ()->GetPhyBand (), staId);
-          length = HePhy::ConvertHeTbPpduDurationToLSigLength (duration,
-                                                               staDev->GetMac ()->GetWifiPhy ()->GetPhyBand ());
+          std::tie (length, duration) = HePhy::ConvertHeTbPpduDurationToLSigLength (duration, txVector,
+                                                                                    staDev->GetMac ()->GetWifiPhy ()->GetPhyBand ());
         }
       txVector.SetLength (length);
 
       staDev->GetPhy ()->Send (WifiConstPsduMap {{staId, psdu}}, txVector);
     }
+
+  // AP's PHY expects to receive a TRIGVECTOR (just once)
+  trigVector.SetLength (length);
+  auto apHePhy = StaticCast<HePhy> (apDev->GetPhy ()->GetPhyEntity (WIFI_MOD_CLASS_HE));
+  apHePhy->SetTrigVector (trigVector, duration);
 }
 
 void
@@ -861,7 +874,9 @@
     {
       if (txBss.find (bss) != txBss.end ())
         {
-          // Due to AID filtering, only stations that are addressed by the MU PPDU do hear the frame
+          // There was a transmission in this BSS.
+          // [DL] Due to AID filtering, only stations that are addressed by the MU PPDU do hear the frame
+          // [UL] The AP hears a TB PPDU sent by all and only the solicited stations
           for (uint8_t sta = 0; sta < nRus; sta++)
             {
               NS_TEST_EXPECT_MSG_EQ (m_received[bss].test (sta), true,
@@ -879,7 +894,8 @@
                                      << (isDlMu ? "by" : "from") << " station [" << +bss << "]["
                                      << +sta << "]");
             }
-          // only the addressed stations actually processed the frames
+          // [DL] Only the addressed stations actually processed the frames
+          // [UL] The AP processed the frames sent by all and only the addressed stations
           for (uint8_t sta = 0; sta < nRus; sta++)
             {
               NS_TEST_EXPECT_MSG_EQ (m_processed[bss].test (sta), true,
@@ -900,10 +916,11 @@
         }
       else
         {
-          // There was no transmission in this BSS. If BSS Color filtering is enabled or no frame
-          // transmission overlaps with the primary20 channel of this BSS, stations in this BSS
-          // did not hear any frame.
-          if (m_useDistinctBssColors
+          // There was no transmission in this BSS.
+          // [DL] If BSS Color filtering is enabled or no frame transmission overlaps with
+          // the primary20 channel of this BSS, stations in this BSS did not hear any frame.
+          // [UL] The AP did not hear any TB PPDU because no TRIGVECTOR was passed to the PHY
+          if (!isDlMu || m_useDistinctBssColors
               || std::none_of (txBss.begin (), txBss.end (),
                                [&](const uint8_t& txAp)
                                {
@@ -925,7 +942,7 @@
             }
           else
             {
-              // stations having the same AID of the stations addressed by the MU PPDI received the frame
+              // [DL] Stations having the same AID of the stations addressed by the MU PPDU received the frame
               for (uint8_t sta = 0; sta < nRus; sta++)
                 {
                   NS_TEST_EXPECT_MSG_EQ (m_received[bss].test (sta), true,
